$nocompile

Dht_port Alias Portc.2
Dht_pin Alias Pinc.2
Dht_ddr Alias Ddrc.2

Declare Function Dht_crc(buff() As Byte , Byval Size As Byte) As Byte
Declare Function Dht_read(byref Thermo As Integer , Byref Humidity As Integer) As Byte

Const Dht_ok = 0                                  '  .
Const Dht_not_sensor = 1                          '   .
Const Dht_crcerr = 2                              '   .
Const Dht_timeout = 3                             '         .

Const Dht_maxcount = 250

Dim Dht_i As Byte
Dim Dht_pinstate As Byte

Goto Dht_m1

Dht_pinwait:
  For Dht_i = 0 To Dht_maxcount
    If Dht_pin = Dht_pinstate.0 Then
      Exit For
    End If
  Next Dht_i
Return

Macro Dht_waitpin
  Gosub Dht_pinwait
  If Dht_i >= Dht_maxcount Then
    Exitcode = Dht_timeout
    Exit Do
  End If
End Macro

Function Dht_crc(buff() As Byte , Byval Size As Byte) As Byte
  Local Crc As Byte , I As Byte
  Crc = 0
  For I = 1 To Size
    Crc = Crc + Buff(i)
  Next I
  Dht_crc = Crc
End Function

Function Dht_read(byref Thermo As Integer , Byref Humidity As Integer) As Byte
   Local Exitcode As Byte , Temp As Long , Crc As Byte , Count As Byte

   Exitcode = Dht_ok
   Thermo = 0
   Humidity = 0
   Temp = 0
   Crc = 0

   Dht_ddr = 1                                    '    .
   Dht_port = 0                                   '  0  .
   Waitms 20
   Dht_ddr = 0                                    '    .
   Waitus 40

   If Dht_pin = 0 Then                            '   .0  .

     Waitus 80

     If Dht_pin = 1 Then                          '   .1  .

        Dht_pinstate = 0
        Gosub Dht_pinwait
        If Dht_i < Dht_maxcount Then

           Count = 32

           Do
              Decr Count
              Dht_pinstate = 1
              Dht_waitpin
              Waitus 34
              If Dht_pin = 1 Then
                Temp.count = 1
                Dht_pinstate = 0
                Dht_waitpin
              End If
           Loop Until Count = 0

           Count = 8

           Do
              Decr Count
              Dht_pinstate = 1
              Dht_waitpin
              Waitus 34
              If Dht_pin = 1 Then
                Crc.count = 1
                Dht_pinstate = 0
                Dht_waitpin
              End If
           Loop Until Count = 0

           If Exitcode = Dht_ok Then
              If Dht_crc(temp() , 4) = Crc Then
                Thermo = Temp
                If Thermo.15 = 1 Then             '  .
                   Thermo = Thermo Xor &H7FFF
                End If
                Humidity = Highw(temp)
              Else
                Exitcode = Dht_crcerr
              End If
           End If

        Else
          Exitcode = Dht_timeout
        End If

     Else
       Exitcode = Dht_not_sensor
     End If

   Else
     Exitcode = Dht_not_sensor
   End If

   Dht_read = Exitcode
End Function



Dht_m1: