
; SDK  Proteus.   PureBasic  C++ ( vsm.hpp).
;  1.0 -    .
;  1.1 -   .
;  1.2 -   IMIXEDMODEL  ICOMPONENT.


;{ thiscall .
CompilerIf #PB_Compiler_OS = #PB_OS_Windows And #PB_Compiler_Processor = #PB_Processor_x86

!macro CALL arg
! {
! clabel = $
! CALL arg
! plabel = clabel-3
! callsize = $-clabel
! load ops dword from plabel
! load opc byte from plabel+4
! If ops=$FF008B50 & (opc=$10 | opc=$50 | opc=$90)
!   If opc=$10
!     db $10
!   Else If (opc=$50 | opc=$90)
!     db $00
!     Repeat callsize
!       load op byte from clabel+callsize-%
!       store byte op at clabel+callsize-%+1
!     End Repeat
!   End If
!   store dword $008BC189 at plabel
!   store byte $FF at plabel+4
! End If
! }

CompilerEndIf
;}

#VSM_API_VERSION = 110
#VSM_BUILD_DATE  = $9ADFBCA5

#WATCHITEM_NAME_SIZE = 128
#WATCHITEM_ADDR_SIZE = 32

#DPF_INPUT      = $01
#DPF_OUTPUT     = $02
#DPF_BIDIR      = $03

; State polarity bits:
#SP_UNDEFINED   = $00           ; The undefined state.
#SP_LOW         = $01           ; Polarity Low.
#SP_FLOAT       = $02           ; Polarity Float (i.e. half volts).
#SP_HIGH        = $03           ; Polarity High.
#SP_MASK        = $03           ; Use To mask off polarity.

; State strength bits:
#SS_FLOAT       = $00           ; Strength Float.
#SS_DRIVEN      = $04           ; Flag bit For driven state.
#SS_WEAK        = $04           ; Strength Weak.
#SS_STRONG      = $0C           ; Strength Strong.
#SS_INJECT      = $14           ; Strength For generators.
#SS_POWER       = $1C           ; Strength Power rail.
#SS_MASK        = $1C           ; Used To mask off strength.

; State flag bits:
#SF_CONTENTION  = $20
#SF_MESSAGE     = $40           ; Message associated With state (?)
#SF_MASK        = $E0           ; Use To mask off flags.

#MIR_X = 1
#MIR_Y = 2

; Flags For controlling property visibility
#SHOW_ALL      = 0
#HIDE_KEYWORD  = 1
#HIDE_VALUE    = 2
#HIDE_ALL      = 3
#HIDE_NOMODIFY = 4

Macro MAKECOLOUR(r,g,b) : r|(g<<8)|(b<<16) : EndMacro

; #Black          = MAKECOLOUR($00,$00,$00)
; #Blue           = MAKECOLOUR($00,$00,$C0)
; #Green          = MAKECOLOUR($00,$C0,$00)
; #Cyan           = MAKECOLOUR($00,$C0,$C0)
; #Red            = MAKECOLOUR($C0,$00,$00)
; #Magenta        = MAKECOLOUR($C0,$00,$C0)
; #Yellow         = MAKECOLOUR($C0,$C0,$00)
; #White          = MAKECOLOUR($C0,$C0,$C0)
#GREY           = MAKECOLOUR($80,$80,$80)
#DARKBLUE       = MAKECOLOUR($00,$00,$40)
#DARKGREEN      = MAKECOLOUR($00,$40,$00)
#DARKCYAN       = MAKECOLOUR($00,$40,$40)
#DARKRED        = MAKECOLOUR($40,$00,$00)
#DARKMAGENTA    = MAKECOLOUR($40,$00,$40)
#DARKYELLOW     = MAKECOLOUR($40,$40,$00)
#DARKGREY       = MAKECOLOUR($40,$40,$40)
#MIDBLUE        = MAKECOLOUR($00,$00,$80)
#MIDGREEN       = MAKECOLOUR($00,$80,$00)
#MIDCYAN        = MAKECOLOUR($00,$80,$80)
#MIDRED         = MAKECOLOUR($80,$00,$00)
#MIDMAGENTA     = MAKECOLOUR($80,$00,$80)
#MIDYELLOW      = MAKECOLOUR($80,$80,$00)
#MIDGREY        = MAKECOLOUR($80,$80,$80)
#LIGHTBLUE      = MAKECOLOUR($00,$00,$C0)
#LIGHTGREEN     = MAKECOLOUR($00,$C0,$00)
#LIGHTCYAN      = MAKECOLOUR($00,$C0,$C0)
#LIGHTRED       = MAKECOLOUR($C0,$00,$00)
#LIGHTMAGENTA   = MAKECOLOUR($C0,$00,$C0)
#LIGHTYELLOW    = MAKECOLOUR($C0,$C0,$00)
#LIGHTGREY      = MAKECOLOUR($C0,$C0,$C0)
#BRIGHTBLUE     = MAKECOLOUR($00,$00,$FF)
#BRIGHTGREEN    = MAKECOLOUR($00,$FF,$00)
#BRIGHTCYAN     = MAKECOLOUR($00,$FF,$FF)
#BRIGHTRED      = MAKECOLOUR($FF,$00,$00)
#BRIGHTMAGENTA  = MAKECOLOUR($FF,$00,$FF)
#BRIGHTYELLOW   = MAKECOLOUR($FF,$FF,$00)
#BRIGHTWHITE    = MAKECOLOUR($FF,$FF,$FF)

#INVISIBLE      = -1
#NOCOLOUR       = -1

; Text justifications:
#TXJ_LEFT   = 0
#TXJ_RIGHT  = 1
#TXJ_CENTRE = 2
#TXJ_BOTTOM = 0
#TXJ_TOP    = 4
#TXJ_MIDDLE = 8




Enumeration ; RUNMODES
  #RM_BATCH=-1
  #RM_START
  #RM_STOP
  #RM_SUSPEND
  #RM_ANIMATE
  #RM_STEPTIME
  #RM_STEPOVER
  #RM_STEPINTO
  #RM_STEPOUT
  #RM_STEPTO
  #RM_META
  #RM_DUMP
EndEnumeration
Macro RUNMODES : b : EndMacro

Enumeration ; ACTIVEDATATYPES
  #ADT_VOID=-1
  #ADT_REAL
  #ADT_BOOLEAN
  #ADT_INTEGER
  #ADT_STATE
  #ADT_PINVOLTAGE
  #ADT_PINSTATE
  #ADT_WIREINFO
  #ADT_SPICEDATA
  #ADT_DSIMDATA
  #ADT_USER=100
EndEnumeration
Macro ACTIVEDATATYPES : b : EndMacro

;Enumeration ;STATE
#UNDEFINED = 0
#TSTATE   = 1
#FSTATE   = -1
#PLO = #SS_POWER  + #SP_LOW
#ILO = #SS_INJECT + #SP_LOW
#SLO = #SS_STRONG + #SP_LOW
#WLO = #SS_WEAK   + #SP_LOW
#FLT = #SS_FLOAT  + #SP_FLOAT
#WHI = #SS_WEAK   + #SP_HIGH
#SHI = #SS_STRONG + #SP_HIGH
#IHI = #SS_INJECT + #SP_HIGH
#PHI = #SS_POWER  +  #SP_HIGH
#WUD = #SS_WEAK   + #SP_UNDEFINED
#SUD = #SS_STRONG + #SP_UNDEFINED
;EndEnumeration
Macro STATE : b : EndMacro

;Enumeration ;DSIMMODES
#DSIMBOOT       = $01
#DSIMSETTLE     = $02
#DSIMNORMAL     = $04
#DSIMEND        = $08
;EndEnumeration
Macro DSIMMODES : b : EndMacro


Enumeration ;DSIMVARS
  #SIMTIMENOW=-1
  #DSIMTDSCALE
EndEnumeration
Macro DSIMVARS : b : EndMacro

;Enumeration ;POPUPTYPES
#PWT_USER     = 0
#PWT_DEBUG    = 1
#PWT_STATUS   = 2
#PWT_MEMORY   = 3
#PWT_WATCH    = 5
#PWT_SOURCE   = 4
#PWT_VAR      = 6
;EndEnumeration
Macro POPUPTYPES : a : EndMacro

; Flags For creating pop-up windows. The bottom 20 bits are reserved For use by VSM,
; whilst the remaining top 12 bits are available For user pop-ups.
;Enumeration ;POPUPFLAGS
  #PWF_VISIBLE       = $00000001
  #PWF_SIZEABLE      = $00000002
  #PWF_LOCKPOSITION  = $00000004
  #PWF_HIDEONANIMATE = $00000008
  #PWF_AUTOREFRESH   = $00000010
  #PWF_WANTKEYBOARD  = $00000020
  #PWF_ACTIVE        = $00008000
  #PWF_INTERNAL      = $80000000
;EndEnumeration
Macro POPUPFLAGS : l : EndMacro


Enumeration ;DATATYPES
  #DT_VOID=-1
  #DT_STRING
  #DT_TEXT
  #DT_BYTE
  #DT_WORD
  #DT_DWORD
  #DT_QWORD
  #DT_IEEE_FLOAT
  #DT_IEEE_DOUBLE
  #DT_HTEC_FLOAT
  #DT_MCHP_FLOAT
  #DT_BIGENDIAN=$8000 
EndEnumeration
Macro DATATYPES : b : EndMacro

Enumeration ;DISPFORMATS
  #DF_VOID=-1
  #DF_BINARY
  #DF_OCTAL
  #DF_HEXADECIMAL
  #DF_SIGNED
  #DF_UNSIGNED
  #DF_FLOAT
  #DF_TEXT
EndEnumeration
Macro DISPFORMATS : b : EndMacro


;Enumeration ;ACTUATEFLAGS
  #ACF_LEFT   =  $00000001
  #ACF_RIGHT  =  $00000002
  #ACF_MIDDLE =  $00000004
  #ACF_INC    =  $00010000
  #ACF_DEC    =  $00020000
  #ACF_TOGGLE =  $00040000
;EndEnumeration
Macro ACTUATEFLAGS : l : EndMacro


;Enumeration ;SPICEMODES
  #SPICETRAN=$1
  #SPICEAC=$2
  #SPICEDC=$70
  #SPICEDCOP=$10
  #SPICETRANOP=$20
  #SPICEDCTRANCURVE=$40
  #SPICEINITFLOAT=$100
  #SPICEINITJCT=$200
  #SPICEINITFIX=$400
  #SPICEINITSMSIG=$800
  #SPICEINITTRAN=$1000
  #SPICEINITPRED=$2000
  #SPICEUIC=$10000 ;   l -   Long.
;EndEnumeration
Macro SPICEMODES : l : EndMacro


Enumeration ;SPICEVARS
  #SPICETIME
  #SPICEOMEGA
  #SPICEDELTA
  #SPICEGMIN
  #SPICEDELMIN
  #SPICEMINBREAK
  #SPICESRCFACT
  #SPICEFINALTIME
EndEnumeration
Macro SPICEVARS : b : EndMacro




; Time Conversion Macros
#DSIMTICK   = 1e-12

; Maximum bits in bus:
#MAXBUSBITS =  32

#EID_BREAKPOINT = $8000000

; Backward compatibility
#DT_LSF_WORD  = #DT_WORD
#DT_MSF_WORD  = #DT_WORD|#DT_BIGENDIAN
#DT_LSF_DWORD = #DT_DWORD
#DT_MSF_DWORD = #DT_DWORD|#DT_BIGENDIAN
#DT_LSF_QWORD = #DT_QWORD
#DT_MSF_QWORD = #DT_QWORD|#DT_BIGENDIAN

; Limits that can be used For arrays, menus IDs etc.
#dMAXDATATYPES   = 10
#MAXDISPFORMATS  = 10


; ID's for system-global  popups:
#PID_LOGWINDOW   = 0
#PID_WATCHWINDOW=  1

; Watch window Interface
#WATCHITEM_NAME_SIZE = 128
#WATCHITEM_ADDR_SIZE = 32

; Loader formats
#FORMAT_BIN   = 0
#FORMAT_HEX   = 1
#FORMAT_S19   = 2
#FORMAT_OMF51 = 3
#FORMAT_UBROF = 4
#FORMAT_COD   = 5
#FORMAT_BASIC = 6
#FORMAT_COFF  = 7

Macro REALTIME : d : EndMacro
Macro ACTIVESTATE : l : EndMacro
Macro ABSTIME : q : EndMacro
Macro EVENTID : l : EndMacro
Macro EVENT : i : EndMacro
Macro RELTIME : q : EndMacro
Macro HGFXSTYLE : i : EndMacro
Macro HTEXTSTYLE : i : EndMacro
Macro LRESULT : l : EndMacro
Macro ADDRESS : l : EndMacro 
Macro IPOPUP : i : EndMacro
Macro POPUPID : l : EndMacro
Macro INSTANCEID : l : EndMacro
Macro COLOUR : l : EndMacro
Macro SPICEFREQ : d : EndMacro
Macro SPICENODE : i : EndMacro
Macro PINHANDLERFN : i : EndMacro
Macro CALLBACKHANDLERFN : i : EndMacro

Macro islow(s) : Bool(s & #SP_MASK = #SP_LOW) : EndMacro
Macro ishigh(s) : Bool(s & #SP_MASK = #SP_HIGH) : EndMacro
Macro isfloating(s) : Bool(s & #SP_MASK = #SP_FLOAT) : EndMacro
Macro iscontention(s) : Bool(s & #SF_CONTENTION) : EndMacro
Macro isdefined(s) : Bool(s <> #SP_UNDEFINED) : EndMacro
Macro ishighlow(s) : s & 1 : EndMacro
Macro polarity(s) : s & #SP_MASK : EndMacro
Macro strength(s) :  s & #SS_MASK : EndMacro

Procedure.ABSTIME dsimtime(t) : ProcedureReturn t/#DSIMTICK : EndProcedure
Procedure.REALTIME realtime(t) : ProcedureReturn t*#DSIMTICK : EndProcedure

Structure BOX
  x1.l : y1.l : x2.l : y2.l
EndStructure

CompilerIf Defined(BOX, #PB_Structure) = 0
  Macro BOX : RECT : EndMacro
CompilerEndIf

Structure SPICEDATA Align 4
  numtimepoints.l
  umpins.l
  *timepoints.Double ; REALTIME
  *nodedata.Double   ; DOUBLE
EndStructure

Structure DSIMDATA Align 4
  numtimepoints.l
  numpins.l
  *timepoints.Quad ;ABSTIME
  *nodedata.Byte
EndStructure

Structure ACTIVEDATA Align 4
  Type.ACTIVEDATATYPES
  StructureUnion
    intval.i
    realval.d
    stateval.STATE
    wireinfo.d[2]    ; Voltage and current
    spicedata.SPICEDATA
    dsimdata.DSIMDATA
    *userinfo        ; Pointer to user data
  EndStructureUnion
EndStructure

Structure ACTIVEEVENT Align 4
  instance.l          ; Design Global Instance value for target indicator.
  *callback           ; Callback Pointer to the active component object.
  element.l           ; Sub-element within parent.
  Data_.ACTIVEDATA    ; Data structure passed to models:
EndStructure

Structure CREATEPOPUPSTRUCT Align 4
  id.POPUPID
  type.POPUPTYPES
  caption.s
  width.i
  height.i
  flags.l
EndStructure

Structure VARITEM Align 4
  name.s[#WATCHITEM_NAME_SIZE]
  loader.l
  seg.l
  address.ADDRESS
  type.DATATYPES
  format.DISPFORMATS
  size.l
  scope_begin.ADDRESS
  scope_end.ADDRESS
EndStructure


Structure VARDATA Align 4
  addr.s[#WATCHITEM_ADDR_SIZE];
  type.DATATYPES
  *memory.Byte
  memsize.l
  offset.l  ; from start of memory block.
EndStructure

Structure aBytes
  Buff.a[0]
EndStructure

Interface ILICENCESERVER
  Authorize(product_id.l, apiver.l=#VSM_API_VERSION)
  AuthorizeEx (product_id.l, apiver.l=#VSM_API_VERSION, builddate.l=#VSM_BUILD_DATE)
  GetID()
  GetName.s()
  GetCompany.s()
  GetExpiryDate.s()
EndInterface

Interface ICPU
  vdmhlr.LRESULT(*cmd,  *Data.Byte)
  loaddata(format.i, seg.i, address.ADDRESS, *Data.Byte, numbytes.i)
  disassemble(address.ADDRESS, numbytes.i)
  getvardata.b(*vip.VARITEM, *vdp.VARDATA)
EndInterface

Interface IDSIMPIN1
  invert.b()
  istate.STATE()
  issteady.b()         ; Will false for return *any* change of activity.
  activity.i()
  isactive.b()
  isinactive.b()
  isposedge.b()
  isnegedge.b()
  isedge.b()           ; Will Return true only For a full edge transition.
  setstate.EVENT(time.ABSTIME, tlh.RELTIME, thl.RELTIME, tgq.RELTIME, state.STATE)
  setstate2.EVENT(time.ABSTIME, tgq.RELTIME, state.STATE)
  setstate3(state.STATE)
  sethandler(*model, phf) ;sethandler(*model.IDSIMMODEL, phf.PINHANDLERFN)
  getnode()
  getstate.STATE()
EndInterface

; Alternate drive Interface Interface - APIVER 1.10

Interface IDSIMPIN2 Extends IDSIMPIN1
  settiming(tlh.RELTIME, thl.RELTIME, tgq.RELTIME)
  setstates(tstate.STATE, fstate.STATE, zstate.STATE)
  drivebool.EVENT(time.ABSTIME, flag.b)
  drivestate.EVENT(time.ABSTIME, state.STATE)
  drivetristate.EVENT(time.ABSTIME)
EndInterface

Macro IDSIMPIN : IDSIMPIN2 : EndMacro


Interface IINSTANCE
  id.s()
  value.s()
  getstrval.s(name.s, *defval.String=#Null)
;  ;getnumval.d(name.s, defval.d=0)
  getnumval(*result.DOUBLE, name.s, defval.d=0)
  getboolval.b(name.s, defval.b=#False)
  gethexval.l(name.s, defval.l=0)
  getinitval.i(name.s, defval.i=0)
  getdelay.RELTIME(name.s, deftime.RELTIME=0)
  
  ; Special property access
  getactivemode() ;.lIACTIVEMODEL
  getinterfacemode() ;.lIINSTANCE
  getmoddata.b(*data.Byte, *size.Long)
  
  ; Access To the nodes And pins:
  getspicenode(namelist.s, required.b) ; .SPICENODE
  getdsimpin(namelist.s, required.b) ; .IDSIMPIN
  
  ; Logging And messaging:
  Log(msg.s, null.i=0)       ; Cdecl  .
  warning(msg.s, null.i=0)   ; Cdecl  .
  error(msg.s, null.i=0)     ; Cdecl  .
  fatal(msg.s, null.i=0)     ; Cdecl  .
  message.b(msg.s, null.i=0) ; Cdecl  .
  
  ; Pop-up window support:
  createpopup(*cps.CREATEPOPUPSTRUCT) ; IPOPUP
  deletepopup(id.POPUPID)
  
  ; Virtual Debug monitor Interface:
  setvdmhlr.b(*x.ICPU)
  
  ; Generic memory loader:
  loadmemory.b(filename.s, *buffer, size.i, base.i=0, shift.i=0)
  
  ; Access To bus pins
  getbuspin(namestem.s, base.i, width.i, required.b) ; IBUSPIN
  getbuspin2(name.s,  *pins.IDSIMPIN, width.i) ; IBUSPIN
EndInterface

Interface IDSIMCKT
  ;systime.ABSTIME()
  ;sysvar.d(var.DSIMVARS)
  sysvar (*result.DOUBLE, var.DSIMVARS)
  setcallback.EVENT(evttime.ABSTIME,  *model, id.EVENTID) ; setcallback.EVENT( evttime.ABSTIME,  *model.IDSIMMODEL, id.EVENTID)
  cancelcallback.b(*event, *model)
  setbreak(breaktime.ABSTIME)
  suspend(*instance.IINSTANCE, msg.s)
  setcallbackex.EVENT(evttime.ABSTIME, *model, *func, id.EVENTID)
  newnode(partid.s, nodename.s)
  newpin(*x.IINSTANCE, *node, name.s, flags.l)
  setclockcallback.EVENT(starttime.ABSTIME, period.RELTIME, *model, *func, id.EVENTID)
EndInterface


Interface IDSIMMODEL
  Isdigital(pinname.s)
  Setup(*instance.IINSTANCE, *dsim.IDSIMCKT)
  Runctrl(mode.RUNMODES)
  Actuate(time.REALTIME, newstate.ACTIVESTATE)
  Indicate(time.REALTIME,  *newstate.ACTIVEDATA)
  Simulate(time.ABSTIME, mode.DSIMMODES)
  Callback(time.ABSTIME, eventid.EVENTID)
EndInterface

; Definition of services provided by an Active Component To an Active Model.
Interface ICOMPONENT_2
  ; Property management:
  getprop.s(name.s);
  getproptext.s()
  addprop(propname.s, item.s, hflags.w)
  delprop(propname.s)
  setproptext(text.s)
  
  ; Active State processing:
  getstate.ACTIVESTATE(element.i, *Data.ACTIVEDATA)
  setstate.b(state.ACTIVESTATE)
  
  ; Graphics management:
  setdrawscale(ppi.i)
  begincache2(*area.BOX)
  begincache(symbol.i)
  endcache()
  
  ; Vector drawing services:
  creategfxstyle.HGFXSTYLE(*name=#Null)
  selectgfxstyle(style.HGFXSTYLE)
  setpenwidth (w.i)
  setpencolour(c.COLOUR)
  setbrushcolour(c.COLOUR)
  drawline(x1.i, y1.i, x2.i, y2.i)
  drawbox(box.BOX)
  drawbox2(x1.i, y1.i, x2.i, y2.i)
  drawcircle(x, y, radius)
  drawbezier(*x.POINT, numpoints=4)
  drawpolyline(*x.POINT, numpoints)
  drawpolygon(*x.POINT, numpoints)
  drawsymbol2(x, y, rot, mir, symbol)
  drawsymbol(symbol);
  drawstate(state.ACTIVESTATE);
  getsymbolarea.b(symbol, *area.BOX)
  getmarker.b(name.s, *pos.POINT=#Null, *rot=#Null, *mir=#Null)
  
  ; Text output services:
  createtextstyle.HTEXTSTYLE(*name=#Null)
  selecttextstyle(style.HTEXTSTYLE)
  settextfont(name.s)
  settextsize(h)
  setbold(f.b)
  setitalic(f.b)
  setunderline(f.b)
  settextcolour(c.COLOUR)
  DrawText(x, y, rot, jflags, text.s) ;, null.i=0 Cdecl  .
  
  ; Pop-up window support:
  createpopup.IPOPUP(*cps.CREATEPOPUPSTRUCT)
  deletepopup(id.POPUPID)
  
  ; Miscellaneous:
  settimestep(time.d)
  error(msg.s, null.i=0) ; Cdecl  .
  repaint(erase.b)
EndInterface

 ;  PureBasic    IComponent     ICOMPONENT_2.
 Macro ICOMPONENT : ICOMPONENT_2 : EndMacro


; Definition of services that a graphical model must provide To an active component
Interface IACTIVEMODEL
  initialize(*cpt.ICOMPONENT)
  getspicemodel.i(primitive.s)
  getdsimmodel.i(primitive.s)
  Plot(state.ACTIVESTATE)
  animate(element.i, *newstate.ACTIVEDATA)
  actuate.b(key.w, x.i, y.i, flags.l)
EndInterface

Interface ISPICECKT
  ismode.b(flags.SPICEMODES)
;  ;sysvar.d(var.SPICEVARS)
  sysvar(*result.DOUBLE, var.SPICEVARS)
  statevar.d(s, n)
  rhs.d(n.SPICENODE)
  rhsold.d(n.SPICENODE)
  irhs.d(n.SPICENODE)
  irhsold.d(n.SPICENODE)
  getnode.SPICENODE(NetName.s)
  newvoltnode.SPICENODE(partid.s, nodename.s)
  newcurnode.SPICENODE(partid.s, nodename.s)
  delnode(node.SPICENODE)
  allocsmp.d(node1.SPICENODE, node2.SPICENODE)
  setbreak.d(time.REALTIME)
  suspend(*instance.IINSTANCE, msg.s)
  allocvars.i(n.i)
  integrate(geq.d, ceq.d, cap.d, statevars.i)
  truncerr(statevars.i, timestep.d)
EndInterface


; Interface To bus pin object - new in APIVER 1.10
Interface IBUSPIN
  settiming(tlh.RELTIME, thl.RELTIME, tz.RELTIME)
  setstates(tstate.STATE, fstate.STATE, zstate.STATE)
  sethandler(*model.IDSIMMODEL, phf.PINHANDLERFN)
  drivebusvalue(time.ABSTIME, value.l)
  drivetristate(tim.ABSTIME)
  drivebitstate(time.ABSTIME, bit.i, state.STATE)
  getbusvalue.l()
  getbusdrive.l()
  getbitstate.STATE(bit.i)
EndInterface


Interface ISPICEMODEL
  isanalog.i(pinname.s)
  setup(*x.IINSTANCE, *x.ISPICECKT)
  runctrl(mode.RUNMODES)
  actuate(time.REALTIME, newstate.ACTIVESTATE)
  indicate.b(time.REALTIME, *newstate.ACTIVEDATA)
  dcload(time.REALTIME, mode.SPICEMODES, *oldrhs.DOUBLE, *newrhs.DOUBLE)
  acload(omega.SPICEFREQ, *rhs.DOUBLE, *irhs.DOUBLE)
  trunc(time.REALTIME, *newtimestep.REALTIME)
  accept(time.REALTIME, *rhs.DOUBLE)
EndInterface

; Interface IMIXEDMODEL ;Extends ISPICEMODEL
;   ;m_IDSIMMODEL ;  IDSIMMODEL.
;   
;   ; Pin typing And connection functions:
;   isanalog.i(pinname.s)
;   isdigital.i(pinname.s)
;   
;   ; Common Functions:
;   runctrl(mode.RUNMODES)
;   actuate(time.REALTIME, newstate.ACTIVESTATE)
;   indicate.b(time.REALTIME, *newstate.ACTIVEDATA)
;   
;   ; Functions called by SPICE:
;   setup(*x.IINSTANCE,  *spice.ISPICECKT)
;   dcload(time.REALTIME, mode.SPICEMODES, *oldrhs.DOUBLE, *newrhs.DOUBLE)
;   acload(omega.SPICEFREQ, *rhs.DOUBLE, *irhs.DOUBLE)
;   trunc(time.REALTIME,  *newtimestep.REALTIME)
;   accept(time.REALTIME, *rhs.DOUBLE)
;   
;   ; Functions called by DSIM:
;   setup2(*x.IINSTANCE, *dsim.IDSIMCKT)
;   simulate(time.ABSTIME, mode.DSIMMODES)
;   callback(time.ABSTIME, eventid.EVENTID)
; EndInterface


Interface IMIXEDMODEL Extends ISPICEMODEL
  ;m_IDSIMMODEL ;  IDSIMMODEL.
  
  ; IDSIMMODEL.
  Isdigital(pinname.s)
  Setup_IDSI(*instance.IINSTANCE, *dsim.IDSIMCKT)
;  Runctrl_IDS(mode.RUNMODES)
;  Actuate_IDS(time.REALTIME, newstate.ACTIVESTATE)
;  Indicate_IDS(time.REALTIME,  *newstate.ACTIVEDATA)
  Simulate(time.ABSTIME, mode.DSIMMODES)
  Callback(time.ABSTIME, eventid.EVENTID)
  
  ; Pin typing And connection functions:
;  isanalog.i(pinname.s)
;  isdigital.i(pinname.s)
  
  ; Common Functions:
;  runctrl(mode.RUNMODES)
;  actuate(time.REALTIME, newstate.ACTIVESTATE)
;  indicate.b(time.REALTIME, *newstate.ACTIVEDATA)
  
  ; Functions called by SPICE:
  ;setup(*x.IINSTANCE,  *spice.ISPICECKT)
  ;dcload(time.REALTIME, mode.SPICEMODES, *oldrhs.DOUBLE, *newrhs.DOUBLE)
  ;acload(omega.SPICEFREQ, *rhs.DOUBLE, *irhs.DOUBLE)
  ;trunc(time.REALTIME,  *newtimestep.REALTIME)
  ;accept(time.REALTIME, *rhs.DOUBLE)
  
  ; Functions called by DSIM:
  ;setup(*x.IINSTANCE, *dsim.IDSIMCKT)
  ;simulate(time.ABSTIME, mode.DSIMMODES)
  ;callback(time.ABSTIME, eventid.EVENTID)
EndInterface

Interface IMSGHLR
  msghlr.LRESULT(HWND, MESSAGE, WPARAM, LPARAM)
EndInterface

; User defined popup window:
Interface IUSERPOPUP
  getprop.s(key.s)
  setprop(key.s, value.s)
  setmsghlr(*handler.IMSGHLR)
  callwindowproc.LRESULT(msg, warg, larg)
EndInterface

; Debug/logging window:
Interface IDEBUGPOPUP
  Print(msg.s, null.i=0) ; Cdecl  .
  dump(*ptr.aBytes, nbytes.i, base.i=0)
EndInterface

; Status display window:
Interface ISTATUSPOPUP
  setarea(columns.i, rows.i, border.i, copy.b)
  setcursorto(pixelx.i, pixely.i)
  getcharwidth.i()
  getcharheight.i()
  Print(message.s, null.i=0) ; Cdecl  .
  Print2(col.i, row.i, textcolour.COLOUR, msg.s, null.i=0) ; Cdecl  .
  setctabstops(*ts, n.i)
  setptabstops(*ts, n.i)
  clear(bkcolour.COLOUR=#NOCOLOUR)
  setredraw.b(on_off.b, redraw_now.b)
  repaint()
EndInterface

; Memory dump window:
Interface IMEMORYPOPUP
  setmemory(baseaddr.ADDRESS, *Data.BYTE, nbytes.i)
  repaint()
EndInterface

Interface IWATCHPOPUP
  ; Offset is the byte offset within the memory block independent of any 'base' associated With the memory
  ; window. For example, If offset is '4' we are refering To the fourth byte in the memory block; if the memory
  ; block As an implied base of, say, 12, this would be address '16'.
  addnameditem(name.s, *x.IMEMORYPOPUP, offset.l, type.DATATYPES, format.DISPFORMATS)
  
  ; This interfaces are used by PROSPICE itself To poll For watchpoints
  initwatchpoints()
  testwatchpoints()
  
EndInterface

; Source debugging window:
Interface ISOURCEPOPUP
  addsdifile.b(file.s)
  setpcaddr.b(addr.ADDRESS)
  isbreakpoint.b( addr.ADDRESS)
  iscurrentline.b(addr.ADDRESS)
  findfirstbpt.b(*addr.ADDRESS)
  findnextbpt.b(*addr.ADDRESS)
  
  addsrcfile.b(file.s, lowlevel.b)
  addcodeline(srclinenum.i, address.ADDRESS)
  addcodelabel(label.s, address.ADDRESS)
  update()
  
  getsteptoaddr.b(*addr.ADDRESS)                  ; Added in release 5.20 SP1 (APIVER 1.03)
  setinsertpos(fileid.i, linenum.i, newblock.b)
  insertline(addr.ADDRESS, opcodes.s, srctext.s)  ; Insert a new line at the current position. (APIVER 1.05)
  findfirstsrcline.b(*addr.ADDRESS)
  findnextsrcline.b(*addr.ADDRESS)
  findlabel.s(addr.ADDRESS)                       ; Return label For specified address (APIVER 1.05)
EndInterface

; Variable Window - new in APIVER 1.05
Interface IVARPOPUP
  setcpu(*cpu.ICPU)
  additem(*vip.VARITEM)
EndInterface

; Extern loader functions - implemented in LOADER.DLL
ImportC #PB_Compiler_FilePath+"Loaders.lib"
  ;load_auto.b(file.s, *a.IINSTANCE, *b.ISOURCEPOPUP, *c.IVARPOPUP, *d.ICPU)
  load_bin.b(file.s, *a.IINSTANCE, *b.ISOURCEPOPUP, *c.IVARPOPUP, *d.ICPU)
  load_hex.b(file.s, *a.IINSTANCE, *b.ISOURCEPOPUP, *c.IVARPOPUP, *d.ICPU)
  load_s19.b(file.s, *a.IINSTANCE, *b.ISOURCEPOPUP, *c.IVARPOPUP, *d.ICPU)
  load_omf51.b(file.s, *a.IINSTANCE, *b.ISOURCEPOPUP, *c.IVARPOPUP, *d.ICPU)
  load_ubrof.b(file.s, *a.IINSTANCE, *b.ISOURCEPOPUP, *c.IVARPOPUP, *d.ICPU)
  load_cod.b(file.s, *a.IINSTANCE, *b.ISOURCEPOPUP, *c.IVARPOPUP, *d.ICPU)
  load_basic.b(file.s, *a.IINSTANCE, *b.ISOURCEPOPUP, *c.IVARPOPUP, *d.ICPU)
  load_coff.b(file.s, *a.IINSTANCE, *b.ISOURCEPOPUP, *c.IVARPOPUP, *d.ICPU)
EndImport


; IDE Options = PureBasic 5.24 LTS (Windows - x86)
; CursorPosition = 491
; FirstLine = 473
; Folding = --------